SizeSelector (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.selectors, class: SizeSelector

# Class SizeSelector

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.selectors.BaseSelector
org.apache.tools.ant.types.selectors.BaseExtendSelector
org.apache.tools.ant.types.selectors.SizeSelector

All Implemented Interfaces:
  `Cloneable, Parameterizable, ResourceSelector, ExtendFileSelector, FileSelector`

public class SizeSelector extends BaseExtendSelector
Selector that filters files based on their size.

Since:
  1.5

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `SizeSelector.ByteUnits`
  Enumerated attribute with the values for units.
  `static class`
  `SizeSelector.SizeComparisons`
  Enumerated attribute with the values for size comparison.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `SIZE_KEY`
  Used for parameterized custom selector
  `static final String`
  `UNITS_KEY`
  Used for parameterized custom selector
  `static final String`
  `WHEN_KEY`
  Used for parameterized custom selector

  ### Fields inherited from class BaseExtendSelector

  `parameters`
  Modifier and Type
  Field
  Description
  `protected Parameter[]`
  `parameters`
  The passed in parameter array.

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SizeSelector()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `isSelected(File basedir, String filename, File file)`
  The heart of the matter.
  `void`
  `setParameters(Parameter... parameters)`
  When using this as a custom selector, this method will be called.
  `void`
  `setUnits(SizeSelector.ByteUnits units)`
  Sets the units to use for the comparison.
  `void`
  `setValue(long size)`
  A size selector needs to know what size to base its selecting on.
  `void`
  `setWhen(SizeSelector.SizeComparisons when)`
  This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.
  `String`
  `toString()`
  Returns a `String` object representing the specified SizeSelector.
  `void`
  `verifySettings()`
  Checks to make sure all settings are kosher.

  ### Methods inherited from class BaseExtendSelector

  `getParameters`
  Modifier and Type
  Method
  Description
  `protected Parameter[]`
  `getParameters()`
  Allows access to the parameters gathered and set within the <custom> tag.

  ### Methods inherited from class BaseSelector

  `getError, setError, setError, validate`
  Modifier and Type
  Method
  Description
  `String`
  `getError()`
  Returns any error messages that have been set.
  `void`
  `setError(String msg)`
  Allows all selectors to indicate a setup error.
  `void`
  `setError(String msg, Throwable cause)`
  Allows all selectors to indicate a setup error.
  `void`
  `validate()`
  Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface FileSelector

  `isSelected`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isSelected(Resource r)`
  Implement a basic `Resource` selection that delegates to this `FileSelector`.

- ## Field Details

  - ### SIZE_KEY

    public static final String SIZE_KEY
    Used for parameterized custom selector
    See Also:
      - Constant Field Values

  - ### UNITS_KEY

    public static final String UNITS_KEY
    Used for parameterized custom selector
    See Also:
      - Constant Field Values

  - ### WHEN_KEY

    public static final String WHEN_KEY
    Used for parameterized custom selector
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### SizeSelector

    public SizeSelector()

- ## Method Details

  - ### toString

    public String toString()
    Returns a `String` object representing the specified SizeSelector. This is "{sizeselector value: " + <"compare", "less", "more", "equal"> + "}".
    Overrides:
      `toString` in class `DataType`
    Returns:
      a string describing this object

  - ### setValue

    public void setValue(long size)
    A size selector needs to know what size to base its selecting on. This will be further modified by the multiplier to get an actual size limit.
    Parameters:
      `size` - the size to select against expressed in units.

  - ### setUnits

    public void setUnits(SizeSelector.ByteUnits units)
    Sets the units to use for the comparison. This is a little complicated because common usage has created standards that play havoc with capitalization rules. Thus, some people will use "K" for indicating 1000's, when the SI standard calls for "k". Others have tried to introduce "K" as a multiple of 1024, but that falls down when you reach "M", since "m" is already defined as 0.001.

    To get around this complexity, a number of standards bodies have proposed the 2^10 standard, and at least one has adopted it. But we are still left with a populace that isn't clear on how capitalization should work.

    We therefore ignore capitalization as much as possible. Completely mixed case is not possible, but all upper and lower forms are accepted for all long and short forms. Since we have no need to work with the 0.001 case, this practice works here.

    This function translates all the long and short forms that a unit prefix can occur in and translates them into a single multiplier.

    Parameters:
      `units` - The units to compare the size to, using an EnumeratedAttribute.

  - ### setWhen

    public void setWhen(SizeSelector.SizeComparisons when)
    This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.
    Parameters:
      `when` - The comparison to perform, an EnumeratedAttribute.

  - ### setParameters

    public void setParameters(Parameter... parameters)
    When using this as a custom selector, this method will be called. It translates each parameter into the appropriate setXXX() call.
    Specified by:
      `setParameters` in interface `Parameterizable`
    Overrides:
      `setParameters` in class `BaseExtendSelector`
    Parameters:
      `parameters` - the complete set of parameters for this selector.

  - ### verifySettings

    public void verifySettings()

    Checks to make sure all settings are kosher. In this case, it means that the size attribute has been set (to a positive value), that the multiplier has a valid setting, and that the size limit is valid. Since the latter is a calculated value, this can only fail due to a programming error.

    If a problem is detected, the setError() method is called.

    Overrides:
      `verifySettings` in class `BaseSelector`

  - ### isSelected

    public boolean isSelected(File basedir, String filename, File file)
    The heart of the matter. This is where the selector gets to decide on the inclusion of a file in a particular fileset.
    Specified by:
      `isSelected` in interface `FileSelector`
    Specified by:
      `isSelected` in class `BaseExtendSelector`
    Parameters:
      `basedir` - A java.io.File object for the base directory.
      `filename` - The name of the file to check.
      `file` - A File object for this filename.
    Returns:
      whether the file should be selected or not.